import sys
import json
import dpath.util

from PySide2.QtUiTools import QUiLoader
from PySide2.QtGui import QIntValidator
from PySide2.QtWidgets import QApplication, QPushButton, QLineEdit, QKeySequenceEdit, QComboBox
from PySide2.QtCore import Qt, QObject, QEvent, QCoreApplication, QFile, Signal, Slot


class Form(QObject):

    def __init__(self, ui_file, parent=None):   # konstruira Form objekt
        super().__init__(parent)                # konstruira QObject objekt

        ui_file = QFile(ui_file)                # inicijalizira QFile objekt
        ui_file.open(QFile.ReadOnly)            # otvara UI file

        loader = QUiLoader()                    # inicijalizira QUiLoader objekt
        self.window = loader.load(ui_file)      # ucitava UI file u window
        ui_file.close()                         # zatvara UI file

        # ----------------------------------- Postavke prozora ------------------------------------------
        self.window.setWindowTitle("Zavrsni")
        self.window.show()
        # -----------------------------------------------------------------------------

        # ----------------------------------- UI elementi ------------------------------------------

        # POT 1
        self.pot_1_startup = self.window.findChild(QLineEdit, 'pot_1_startup')
        self.pot_1_which = self.window.findChild(QComboBox, 'pot_1_which')
        self.pot_1_steps = self.window.findChild(QLineEdit, 'pot_1_steps')
        # self.pot_1_steps.setValidator(QIntValidator(0,100))
            # up
        self.pot_1_up_keypress = self.window.findChild(QKeySequenceEdit, 'pot_1_up_keypress')
        self.pot_1_up_script = self.window.findChild(QLineEdit, 'pot_1_up_script')
            # down
        self.pot_1_down_keypress = self.window.findChild(QKeySequenceEdit, 'pot_1_down_keypress')
        self.pot_1_down_script = self.window.findChild(QLineEdit, 'pot_1_down_script')

        # POT 2
        self.pot_2_startup = self.window.findChild(QLineEdit, 'pot_2_startup')
        self.pot_2_which = self.window.findChild(QComboBox, 'pot_2_which')
        self.pot_2_steps = self.window.findChild(QLineEdit, 'pot_2_steps')
        # self.pot_2_steps.setValidator(QIntValidator(0,100))
            # up
        self.pot_2_up_keypress = self.window.findChild(QKeySequenceEdit, 'pot_2_up_keypress')
        self.pot_2_up_script = self.window.findChild(QLineEdit, 'pot_2_up_script')
            # down
        self.pot_2_down_keypress = self.window.findChild(QKeySequenceEdit, 'pot_2_down_keypress')
        self.pot_2_down_script = self.window.findChild(QLineEdit, 'pot_2_down_script')

        # POT 3
        self.pot_3_startup = self.window.findChild(QLineEdit, 'pot_3_startup')
        self.pot_3_which = self.window.findChild(QComboBox, 'pot_3_which')
        self.pot_3_steps = self.window.findChild(QLineEdit, 'pot_3_steps')
        # self.pot_3_steps.setValidator(QIntValidator(0,100))
            # up
        self.pot_3_up_keypress = self.window.findChild(QKeySequenceEdit, 'pot_3_up_keypress')
        self.pot_3_up_script = self.window.findChild(QLineEdit, 'pot_3_up_script')
            # down
        self.pot_3_down_keypress = self.window.findChild(QKeySequenceEdit, 'pot_3_down_keypress')
        self.pot_3_down_script = self.window.findChild(QLineEdit, 'pot_3_down_script')

        # Button 1
            # on
        self.button_1_on_which = self.window.findChild(QComboBox, 'button_1_on_which')
        self.button_1_on_keypress = self.window.findChild(QKeySequenceEdit, 'button_1_on_keypress')
        self.button_1_on_script= self.window.findChild(QLineEdit, 'button_1_on_script')
            # off
        self.button_1_off_which = self.window.findChild(QComboBox, 'button_1_off_which')
        self.button_1_off_keypress = self.window.findChild(QKeySequenceEdit, 'button_1_off_keypress')
        self.button_1_off_script = self.window.findChild(QLineEdit, 'button_1_off_script')

        # Button 2
            # on
        self.button_2_on_which = self.window.findChild(QComboBox, 'button_2_on_which')
        self.button_2_on_keypress = self.window.findChild(QKeySequenceEdit, 'button_2_on_keypress')
        self.button_2_on_script = self.window.findChild(QLineEdit, 'button_2_on_script')
            # off
        self.button_2_off_which = self.window.findChild(QComboBox, 'button_2_off_which')
        self.button_2_off_keypress = self.window.findChild(QKeySequenceEdit, 'button_2_off_keypress')
        self.button_2_off_script = self.window.findChild(QLineEdit, 'button_2_off_script')

        # Ultrasonic
            # found
        self.ultrasonic_found_which = self.window.findChild(QComboBox, 'ultrasonic_found_which')
        self.ultrasonic_found_keypress = self.window.findChild(QKeySequenceEdit, 'ultrasonic_found_keypress')
        self.ultrasonic_found_script = self.window.findChild(QLineEdit, 'ultrasonic_found_script')
            # lost
        self.ultrasonic_lost_which = self.window.findChild(QComboBox, 'ultrasonic_lost_which')
        self.ultrasonic_lost_keypress = self.window.findChild(QKeySequenceEdit, 'ultrasonic_lost_keypress')
        self.ultrasonic_lost_script = self.window.findChild(QLineEdit, 'ultrasonic_lost_script')

        # Window picker combo box
        self.active_window = self.window.findChild(QComboBox, 'active_window')

        # Add new app button
        self.add_app = self.window.findChild(QLineEdit, 'add_app')

        # Save and run button
        self.save = self.window.findChild(QPushButton, 'save')

        # ----------------------------------- Signali ------------------------------------------

        # POT 1
        self.pot_1_startup.editingFinished.connect(self.save_startup)
        self.pot_1_which.activated.connect(self.save_which)
        self.pot_1_steps.editingFinished.connect(self.save_steps)
            # up
        self.pot_1_up_keypress.editingFinished.connect(self.save_keypress)
        self.pot_1_up_script.editingFinished.connect(self.save_script)
            # down
        self.pot_1_down_keypress.editingFinished.connect(self.save_keypress)
        self.pot_1_down_script.editingFinished.connect(self.save_script)

        # POT 2
        self.pot_2_startup.editingFinished.connect(self.save_startup)
        self.pot_2_which.activated.connect(self.save_which)
        self.pot_2_steps.editingFinished.connect(self.save_steps)
            # up
        self.pot_2_up_keypress.editingFinished.connect(self.save_keypress)
        self.pot_2_up_script.editingFinished.connect(self.save_script)
            # down
        self.pot_2_down_keypress.editingFinished.connect(self.save_keypress)
        self.pot_2_down_script.editingFinished.connect(self.save_script)

        # POT 3
        self.pot_3_startup.editingFinished.connect(self.save_startup)
        self.pot_3_which.activated.connect(self.save_which)
        self.pot_3_steps.editingFinished.connect(self.save_steps)
            # up
        self.pot_3_up_keypress.editingFinished.connect(self.save_keypress)
        self.pot_3_up_script.editingFinished.connect(self.save_script)
            # down
        self.pot_3_down_keypress.editingFinished.connect(self.save_keypress)
        self.pot_3_down_script.editingFinished.connect(self.save_script)

        # Button 1
            # on
        self.button_1_on_which.activated.connect(self.save_which)
        self.button_1_on_keypress.editingFinished.connect(self.save_keypress)
        self.button_1_on_script.editingFinished.connect(self.save_script)
            # off
        self.button_1_off_which.activated.connect(self.save_which)
        self.button_1_off_keypress.editingFinished.connect(self.save_keypress)
        self.button_1_off_script.editingFinished.connect(self.save_script)

        # Button 2
            # on
        self.button_2_on_which.activated.connect(self.save_which)
        self.button_2_on_keypress.editingFinished.connect(self.save_keypress)
        self.button_2_on_script.editingFinished.connect(self.save_script)
            # off
        self.button_2_off_which.activated.connect(self.save_which)
        self.button_2_off_keypress.editingFinished.connect(self.save_keypress)
        self.button_2_off_script.editingFinished.connect(self.save_script)

        # Ultrasonic
            # found
        self.ultrasonic_found_which.activated.connect(self.save_which)
        self.ultrasonic_found_keypress.editingFinished.connect(self.save_keypress)
        self.ultrasonic_found_script.editingFinished.connect(self.save_script)
            # lost
        self.ultrasonic_lost_which.activated.connect(self.save_which)
        self.ultrasonic_lost_keypress.editingFinished.connect(self.save_keypress)
        self.ultrasonic_lost_script.editingFinished.connect(self.save_script)

        # Window picker combo box
        self.active_window.activated.connect(self.choose_window)

        # Add new app button
        self.add_app.editingFinished.connect(self.add_new_app)

        # Save and run button
        self.save.clicked.connect(self.update_config)
        # -----------------------------------------------------------------------------
        self.load_data()
        # -----------------------------------------------------------------------------

    def map_data(self):
        current_window = self.active_window.currentText()
        self.lista = {
            self.pot_1_startup:             'setup/POT_1',
            self.pot_1_which:               'apps/' + current_window + '/POT_1/which',
            self.pot_1_steps:               'apps/' + current_window + '/POT_1/steps',
            self.pot_1_up_keypress:         'apps/' + current_window + '/POT_1/keypress/up',
            self.pot_1_up_script:           'apps/' + current_window + '/POT_1/script/up',
            self.pot_1_down_keypress:       'apps/' + current_window + '/POT_1/keypress/down',
            self.pot_1_down_script:         'apps/' + current_window + '/POT_1/script/down',
            self.pot_2_startup:             'setup/POT_2',
            self.pot_2_which:               'apps/' + current_window + '/POT_2/which',
            self.pot_2_steps:               'apps/' + current_window + '/POT_2/steps',
            self.pot_2_up_keypress:         'apps/' + current_window + '/POT_2/keypress/up',
            self.pot_2_up_script:           'apps/' + current_window + '/POT_2/script/up',
            self.pot_2_down_keypress:       'apps/' + current_window + '/POT_2/keypress/down',
            self.pot_2_down_script:         'apps/' + current_window + '/POT_2/script/down',
            self.pot_3_startup:             'setup/POT_3',
            self.pot_3_which:               'apps/' + current_window + '/POT_3/which',
            self.pot_3_steps:               'apps/' + current_window + '/POT_3/steps',
            self.pot_3_up_keypress:         'apps/' + current_window + '/POT_3/keypress/up',
            self.pot_3_up_script:           'apps/' + current_window + '/POT_3/script/up',
            self.pot_3_down_keypress:       'apps/' + current_window + '/POT_3/keypress/down',
            self.pot_3_down_script:         'apps/' + current_window + '/POT_3/script/down',
            self.button_1_on_which:         'apps/' + current_window + '/Button_1_on/which',
            self.button_1_on_keypress:      'apps/' + current_window + '/Button_1_on/keypress',
            self.button_1_on_script:        'apps/' + current_window + '/Button_1_on/script',
            self.button_1_off_which:        'apps/' + current_window + '/Button_1_off/which',
            self.button_1_off_keypress:     'apps/' + current_window + '/Button_1_off/keypress',
            self.button_1_off_script:       'apps/' + current_window + '/Button_1_off/script',
            self.button_2_on_which:         'apps/' + current_window + '/Button_2_on/which',
            self.button_2_on_keypress:      'apps/' + current_window + '/Button_2_on/keypress',
            self.button_2_on_script:        'apps/' + current_window + '/Button_2_on/script',
            self.button_2_off_which:        'apps/' + current_window + '/Button_2_off/which',
            self.button_2_off_keypress:     'apps/' + current_window + '/Button_2_off/keypress',
            self.button_2_off_script:       'apps/' + current_window + '/Button_2_off/script',
            self.ultrasonic_found_which:    'apps/' + current_window + '/Ultrasonic_found/which',
            self.ultrasonic_found_keypress: 'apps/' + current_window + '/Ultrasonic_found/keypress',
            self.ultrasonic_found_script:   'apps/' + current_window + '/Ultrasonic_found/script',
            self.ultrasonic_lost_which:     'apps/' + current_window + '/Ultrasonic_lost/which',
            self.ultrasonic_lost_keypress:  'apps/' + current_window + '/Ultrasonic_lost/keypress',
            self.ultrasonic_lost_script:    'apps/' + current_window + '/Ultrasonic_lost/script'
        }

    def load_data(self):
        self.active_window.clear()
        for app in data['apps']:
            self.active_window.addItem(app)
        self.choose_window()

    @Slot()
    def update_config(self):
        with open('config.json', "w") as config_file:
          json.dump(data, config_file, indent=4)

    @Slot()
    def choose_window(self):
        self.map_data()
        for key, value in self.lista.items():
            if type(key) == QLineEdit:
                key.setText(str(dpath.util.get(data, value)))       # string konverzija zbog steps podatka
            elif type(key) == QComboBox:
                key.setCurrentText(dpath.util.get(data, value))
            elif type(key) == QKeySequenceEdit:
                key.setKeySequence(dpath.util.get(data, value))

    @Slot()
    def add_new_app(self):
        if self.sender().text() != '':
            self.active_window.clear()
            template = {
                        self.sender().text(): {
                            "POT_1": {
                                "which": "",
                                "keypress": {
                                    "up": "",
                                    "down": ""
                                },
                                "script": {
                                    "up": "",
                                    "down": ""
                                },
                                "steps": 100
                            },
                            "POT_2": {
                                "which": "keypress",
                                "keypress": {
                                    "up": "",
                                    "down": ""
                                },
                                "script": {
                                    "setup": "",
                                    "up": "",
                                    "down": ""
                                },
                                "steps": 100
                            },
                            "POT_3": {
                                "which": "keypress",
                                "keypress": {
                                    "up": "",
                                    "down": ""
                                },
                                "script": {
                                    "up": "",
                                    "down": ""
                                },
                                "steps": 100
                            },
                            "Button_1_on": {
                                "which": "keypress",
                                "keypress": "",
                                "script": ""
                            },
                            "Button_1_off": {
                                "which": "keypress",
                                "keypress": "",
                                "script": ""
                            },
                            "Button_2_on": {
                                "which": "keypress",
                                "keypress": "",
                                "script": ""
                            },
                            "Button_2_off": {
                                "which": "keypress",
                                "keypress": "",
                                "script": ""
                            },
                            "Ultrasonic_found": {
                                "which": "keypress",
                                "keypress": "",
                                "script": ""
                            },
                            "Ultrasonic_lost": {
                                "which": "keypress",
                                "keypress": "",
                                "script": ""
                            }
                        }
            }
            dpath.util.merge(data['apps'], template)
            for app in data['apps']:
                self.active_window.addItem(app)
            self.add_app.clear()
        else:
            pass

    @Slot()
    def save_startup(self):
        dpath.util.set(data, self.lista[self.sender()], self.sender().text())

    @Slot()
    def save_which(self):
        dpath.util.set(data, self.lista[self.sender()], self.sender().currentText())

    @Slot()
    def save_steps(self):
        try:
            value = int(self.sender().text())
            if self.sender().text() != '' and value in range(0,101):
                dpath.util.set(data, self.lista[self.sender()], int(self.sender().text()))
            else:
                self.sender().clear()
        except ValueError:
            self.sender().clear()

    @Slot()
    def save_keypress(self):
        value = self.sender().keySequence().toString().lower()
        dpath.util.set(data, self.lista[self.sender()], value)

    @Slot()
    def save_script(self):
        dpath.util.set(data, self.lista[self.sender()], self.sender().text())


if __name__ == "__main__":
    QCoreApplication.setAttribute(Qt.AA_ShareOpenGLContexts)
    app = QApplication(sys.argv)

    with open('config.json') as config_file:                # citanje config.json datoteke
        data = json.load(config_file)                       # spremanje u varijablu data

    form = Form('mainwindow.ui')                # otvara UI file

    sys.exit(app.exec_())
